<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglMemCmemAllocator.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_04d7255da8042b9b4e4fa472b0bba349.html">hawking</a></li><li class="navelem"><a class="el" href="dir_9a508e87abb63971d28369ce58dcd697.html">mem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglMemCmemAllocator.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglMemCmemAllocator_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLMEMCMEMALLOCATOR_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLMEMCMEMALLOCATOR_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment">//#include &lt;stdio.h&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include &lt;limits&gt;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &lt;cmem.h&gt;</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#include &lt;unistd.h&gt;</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment">//using namespace std;</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"> * MACROS</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#define     CMEM_START 0xC000000//&quot;0x80000000&quot;//</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#define     CMEM_END   0xC5FFFFF//&quot;0x81000000&quot;</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#define     BLOCK_BOUNDARY  0x1000</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DATA_TYPE&gt;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keywordtype">bool</span> isAllocCMEM(DATA_TYPE * p)</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;{</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;   off_t phys = (off_t) CMEM_getPhys(p);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;   <span class="keywordflow">if</span> (phys &gt;= CMEM_START &amp;&amp; phys &lt;= CMEM_END)</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;   <span class="keywordflow">else</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;}</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DATA_TYPE&gt;</div>
<div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="classTIGLMemCmemAllocator.html">   95</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a>: <span class="keyword">public</span> allocator&lt;DATA_TYPE&gt;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;{</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="comment">//    typedefs</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   <span class="keyword">typedef</span> DATA_TYPE value_type;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;   <span class="keyword">typedef</span> value_type* pointer;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">const</span> value_type* const_pointer;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;   <span class="keyword">typedef</span> value_type&amp; reference;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">const</span> value_type&amp; const_reference;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="keyword">typedef</span> std::size_t size_type;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="keyword">typedef</span> std::ptrdiff_t difference_type;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;   <span class="keyword">static</span> CMEM_AllocParams cmemAllocParams;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   <span class="keyword">static</span> uint32_t globalAlloc;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   <span class="keyword">static</span> <span class="keywordtype">bool</span> flagMemoryAvailable;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   <span class="comment">//    convert an allocator&lt;DATA_TYPE&gt; to allocator&lt;U&gt;</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> U&gt;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   <span class="keyword">struct </span>rebind</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;   {</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;      <span class="keyword">typedef</span> <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator&lt;U&gt;</a> other;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   };</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;   <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a>() :</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;         allocator&lt;DATA_TYPE&gt;()</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;   {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;      cmemAllocParams.type = CMEM_HEAP;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;      cmemAllocParams.flags = CMEM_CACHED;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;   }</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;   <span class="keyword">inline</span> ~<a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a>()</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   {</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;   }</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a>(<span class="keyword">const</span> <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a> &amp; alloc) :</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;         allocator&lt;DATA_TYPE&gt;(alloc)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   {</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      cmemAllocParams.type = CMEM_HEAP;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;      cmemAllocParams.flags = CMEM_CACHED;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   }</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">class</span> U&gt;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a>(<span class="keyword">const</span> <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator&lt;U&gt;</a>&amp; alloc) :</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;         allocator&lt;DATA_TYPE&gt;(alloc)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;      cmemAllocParams.type = CMEM_HEAP;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;      cmemAllocParams.flags = CMEM_CACHED;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;   }</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;   <span class="comment">//    address</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;   <span class="keyword">inline</span> pointer address(reference r)</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;   {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;      <span class="keywordflow">return</span> &amp;r;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   }</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   <span class="keyword">inline</span> const_pointer address(const_reference r)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   {</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;      <span class="keywordflow">return</span> &amp;r;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   }</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   <span class="comment">//    memory allocation</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;   <span class="keyword">inline</span> pointer allocate(size_type cnt, <span class="keyword">typename</span> std::allocator&lt;void&gt;::const_pointer = 0)</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;   {</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      pointer p;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;      <span class="keywordflow">if</span> (flagMemoryAvailable == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;      {</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;         p = (pointer) CMEM_alloc(cnt * <span class="keyword">sizeof</span>(DATA_TYPE), &amp;cmemAllocParams);   <span class="comment">//(pointer)malloc(cnt*sizeof(DATA_TYPE));//</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;         <span class="keywordflow">if</span> (p == NULL)</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;         {</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;!!! warning: CMEM alloc fails, allocating from heap&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            p = (pointer) malloc(cnt * <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            flagMemoryAvailable = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;         }</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;         <span class="keywordflow">else</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;         {</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="comment">// adding some delay</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="preprocessor">#ifdef DEBUG_ENABLE</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            <span class="comment">//          usleep(1000);</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;alloc( &quot;</span> &lt;&lt; cnt&lt;&lt; <span class="stringliteral">&quot;) virtual: &quot;</span> &lt;&lt; p &lt;&lt; <span class="stringliteral">&quot;, Physical: &quot;</span> &lt;&lt; (pointer)CMEM_getPhys(p) &lt;&lt; endl;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;         }</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;      }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;      <span class="keywordflow">else</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;      {</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;         p = (pointer) malloc(cnt * <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;      }</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="preprocessor">#ifdef DEBUG_ENABLE</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;      globalAlloc += cnt * <span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;globalAlloc + &quot;</span> &lt;&lt; cnt * <span class="keyword">sizeof</span>(DATA_TYPE)&lt;&lt;<span class="stringliteral">&quot;= &quot;</span> &lt;&lt; globalAlloc &lt;&lt; endl;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;      <span class="keywordflow">return</span> p;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;   }</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> deallocate(pointer p, size_type)</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;   {</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;      <span class="comment">//::operator delete(p);</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;      <span class="comment">// check if from CMEM</span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;      <span class="keywordflow">if</span> (p)</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;      {</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;         <span class="keywordflow">if</span> (isAllocCMEM(p))</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;         {</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="preprocessor">#ifdef DEBUG_ENABLE</span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="comment">//              cout &lt;&lt; &quot;########## CMEM dealloc: &quot;&lt;&lt; p &lt;&lt; &quot;phys = &quot; &lt;&lt; (pointer)CMEM_getPhys(p)&lt;&lt; endl;</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            CMEM_free(p, &amp;cmemAllocParams);</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            flagMemoryAvailable = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;         }</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;         <span class="keywordflow">else</span></div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;         {</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="comment">//              cout &lt;&lt; &quot;heap dealloc : &quot; &lt;&lt; p &lt;&lt; endl;</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            free(p);</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;         }</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;      }</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;   }</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;   <span class="comment">//    size</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;   <span class="keyword">inline</span> size_type max_size()<span class="keyword"> const</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="keyword">   </span>{</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;      <span class="keywordflow">return</span> numeric_limits &lt; size_type &gt; ::max() / <span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;   }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;   <span class="comment">//    construction/destruction</span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> construct(pointer p, <span class="keyword">const</span> DATA_TYPE&amp; t)</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;   {</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;      <span class="keyword">new</span> (p) DATA_TYPE(t);</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;   }</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">void</span> destroy(pointer p)</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;   {</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;      p-&gt;~DATA_TYPE();</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;   }</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator==(<a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a> <span class="keyword">const</span>&amp;)</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;   {</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;   }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator!=(<a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a> <span class="keyword">const</span>&amp; a)</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;   {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;      <span class="keywordflow">return</span> !operator==(a);</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   }</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;};</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="comment">//    end of class TIGLMemCmemAllocator</span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DATA_TYPE&gt;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;uint32_t <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator&lt;DATA_TYPE&gt;::globalAlloc</a> = 0;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DATA_TYPE&gt;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;CMEM_AllocParams <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator&lt;DATA_TYPE&gt;::cmemAllocParams</a>;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DATA_TYPE&gt;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator&lt;DATA_TYPE&gt;::flagMemoryAvailable</a> = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLMEMCMEMALLOCATOR_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLMemCmemAllocator_html"><div class="ttname"><a href="classTIGLMemCmemAllocator.html">TIGLMemCmemAllocator</a></div><div class="ttdoc">Customized allocator using CMEM module rather than default malloc. </div><div class="ttdef"><b>Definition:</b> tiglMemCmemAllocator.hpp:95</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Mar 16 2015 14:15:13 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
